#ifndef __UTILS_H__
#define __UTILS_H__

#include <math.h>
#include <vector>

class MathUtils
{
 public:
  static double CalculatePosteriorFromLLK(std::vector<double> &llk)
 { 
  if(llk.size()==0) { fprintf(stderr, "Log lk is emptye!\n"); exit(1); }

  int max_idx = 0;
  double max_llk = llk[0];

  for(int i=1; i<llk.size(); i++) if(max_llk<llk[i]) { max_llk = llk[i]; max_idx = i; }

  std::vector<double> ratio;
  ratio.resize(llk.size());
  double ratio_sum = 0.0;

  for(int i=0; i<ratio.size(); i++){
    ratio[i] = pow10(llk[i]-llk[max_idx]);
  }

  for(int i=0; i<ratio.size(); i++) ratio_sum += ratio[i];

  double post = 1./ratio_sum;

  return(post);
 }

 static double CalculatePosteriorFromLLK(std::vector<double> &llk, int post_idx)
 { 
  if(llk.size()==0) {fprintf(stderr, "Log lk is emptye!\n"); exit(1); }
  if(post_idx<0 || post_idx>=llk.size()) { fprintf(stderr, "Posterior index out of range!\n"); exit(1); }

  int max_idx = 0;
  double max_llk = llk[0];

  for(int i=1; i<llk.size(); i++) if(max_llk<llk[i]) { max_llk = llk[i]; max_idx = i; }

  std::vector<double> ratio;
  ratio.resize(llk.size());
  double ratio_sum = 0.0;

  for(int i=0; i<ratio.size(); i++)
    ratio[i] = pow10(llk[i]-llk[max_idx]);

  for(int i=0; i<ratio.size(); i++) ratio_sum += ratio[i];

  double post = ratio[post_idx]/ratio_sum;

  return(post);
 }

};

#endif
